<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<?php
	require( "library/all.phplib" );

	$conf = LoadConfiguration( "../mmeasure.conf" );

	$link = mysql_connect( $conf[ 'MYSQL_HOST' ], $conf[ 'MYSQL_USER' ], $conf[ 'MYSQL_PASSWORD' ] )
		or die( "Could not connect : " . mysql_error() );

	$report = array();
	$report[ 'now' ] = strftime( "%Y/%m/%d %H:%M:%S" );

	$query = "show status";
	$result = mysql_query( $query ) or die( "Query failed : " . mysql_error() );
	$status = array();
	$comms_raw = array();
	while ( $var = mysql_fetch_array( $result ) )
	{
		$status[ "$var[0]" ] = $var[ 1 ];
		if ( ( $var[ 1 ] > 0 ) && ( preg_match( "/^com_/i", $var[ 0 ] ) ) )
		{
			$comms_raw[] = array( preg_replace( "/^com_/i", "", $var[ 0 ] ), $var[ 1 ] );
		}
	}
	$comms = matrix_sort( $comms_raw, 1 );

	$query = "show variables";
	$result = mysql_query( $query ) or die( "Query failed : " . mysql_error() );
	$variables = array();
	while ( $var = mysql_fetch_array( $result ) )
	{
		$variables[ "$var[0]" ] = $var[ 1 ];
	}

	$query = "show innodb status";
	$result = mysql_query( $query ) or die( "Query failed : " . mysql_error() );
	$var = mysql_fetch_array( $result );
	$innodb_status = htmlspecialchars( $var[ 0 ] );

	$report[ 'uptime' ] = round( $status[ 'Uptime' ] / 3600, 2 );
	$report[ 'up_since' ] = strftime( "%Y/%m/%d %H:%M:%S", time() - $status[ 'Uptime' ] );

	$report[ 'connection_used_rate' ] = round( 
		$status[ 'Max_used_connections' ] / $variables[ 'max_connections' ] * 100, 2 );

	if ( $variables[ 'query_cache_size' ] != 0 )
	{
		$report[ 'query_cache_rate' ] = round( 
			( $variables[ 'query_cache_size' ] - $status[ 'Qcache_free_memory' ] ) / $variables[ 'query_cache_size' ] * 100, 2 );
	}
	else
	{
		$report[ 'query_cache_rate' ] = "-";
	}

	$report[ 'myisam_key_used' ] = MyIsamKeyUsed( $status[ 'Key_reads' ], $status[ 'Key_read_requests' ] );

	$report[ 'myisam_key_buffer_used' ] = (int) ( $status[ 'Key_blocks_used' ] * 1024 / $variables[ 'key_buffer_size' ] * 100 );

	$report[ 'temp_hit_rate' ] = TemporaryTableHitRate( $status[ 'Created_tmp_disk_tables' ], $status[ 'Created_tmp_tables' ] );

	$report[ 'current_table_cache_used_rate' ] = round( $status[ 'Open_tables' ] / $variables[ 'table_cache' ] * 100, 2 );

	$report[ 'table_cache_hit_rate' ] = TableCacheHitRate( $status[ 'Opened_tables' ], $status[ 'Open_tables' ] );

	require( "items_definition.php" );

	$key = $_GET[ "key" ];
	$term = $_GET[ "term" ];
	if ( $term == "" )
	{
		$term = "hour";
	}
	$size = $_GET[ "size" ];

	foreach ( $items as $item )
	{
		if ( $item[ 0 ] == $key )
		{
			$name = $item[ 0 ];
			$title = $item[ 1 ];
			$description = $item[ 2 ];
			$advice = $item[ 3 ];
			$parameters = $item[ 4 ];
			$checkes = $item[ 5 ];
		}
	}

	if ( $conf[ "MYSQL_SLOW_QUERY_LOG" ] != "" )
	{
		$slow_queries_log = mb_split( "\n", file_get_contents( $conf[ "MYSQL_SLOW_QUERY_LOG" ] ) );
		$i = 0;
		$in_query = 0;
		foreach ( $slow_queries_log as $index => $line )
		{
			if ( mb_ereg( "^# Time: (.*)$", $line, $values ) )
			{
				if ( $in_query == 1 )
				{
					$i++;
					$in_query = 0;
				}
				$slow_queries_datas[ $i ][ "time" ] = preg_replace( "/^(..)(..)(..) (.*)$/", "$1/$2/$3<br>$4", $values[ 1 ] );
			}
			else if ( mb_ereg( "^# User\@Host: (.*)$", $line, $values ) )
			{
				if ( $in_query == 1 )
				{
					$i++;
					$in_query = 0;
				}
				$slow_queries_datas[ $i ][ "user_host" ] = $values[ 1 ];
			}
			else if ( mb_ereg( "^# Query_time: (.*) Lock_time: (.*) Rows_sent: (.*) Rows_examined: (.*)$", $line, $values ) )
			{
				if ( $in_query == 1 )
				{
					$i++;
					$in_query = 0;
				}
				$slow_queries_datas[ $i ][ "query_time" ] = $values[ 1 ];
				$slow_queries_datas[ $i ][ "lock_time" ] = $values[ 2 ];
				$slow_queries_datas[ $i ][ "rows_sent" ] = $values[ 3 ];
				$slow_queries_datas[ $i ][ "rows_examined" ] = $values[ 4 ];
				$in_query = 1;
			}
			else
			{
				if ( $in_query == 1 )
				{
					if ( !mb_ereg( "started with:$", $line ) && 
						!mb_ereg( "^Tcp port: ", $line ) && 
						!mb_ereg( "^Time ", $line ) )
					{
						$slow_queries_datas[ $i ][ "query" ] .= $line . "<br />";
					}
				}
			}
		}
	}
?>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=euc-jp">
<title>mMeasure - <?php print $report[ 'now' ]; ?></title>
<style type="text/css" media="all">@import "style.css";</style>
</head>

<body>

<table>
<tr id="comments">
	<td id="logo">
		<a href="http://mmeasure.sourceforge.jp/"><img src="images/logo.gif"></a>
	</td>
	<td id="primary">
		߻ <?php print $report[ 'now' ]; ?><br />
		MySQLϢ³ư֡ <?php print $report[ 'uptime' ]; ?>  <?php print round( $report[ 'uptime' ] / 24, 2 ); ?> <br />
		MySQLư <?php print $report[ 'up_since' ]; ?><br />
		<p>
		<?php print MessageUptime( $report[ 'uptime' ] ); ?>
		</p>
	</td>
	<td>
		<p>
		꡼<?php print MessageLog( $variables[ 'log_slow_queries' ] ); ?><br />
		Хʥ<?php print MessageLog( $variables[ 'log_bin' ] ); ?><br />
		̥꡼<?php print MessageLog( $variables[ 'log' ] ); ?><br />
		</p>
		<p>
		<a href="detail.php?key=variables" target="varialbes">Сѿɽ</a><br />
		<a href="detail.php?key=status" target="status">ơɽ</a><br />
		<a href="detail.php?key=innodb_status" target="innodb_status">InnoDBơɽ</a><br />
		</p>
	</td>
</tr>
</table>


<?php
	if ( $size == "small" )
	{
?>
<p>
ɽñ̤ڤؤ<a href="?term=hour&size=small"></a><a href="?term=day&size=small"></a><a href="?term=week&size=small"></a><a href="?term=month&size=small"></a><a href="?term=year&size=small">ǯ</a><br />
<a href="?term=<?php print( $term ); ?>&size=large">ܺɽ</a>
</p>
<table id="main" cellspacing="12">
<?php
		$i = 0;
		foreach ( $items as $item )
		{
			$name = $item[ 0 ];
			$title = $item[ 1 ];
			if ( $i % 3 == 0 )
			{
?>
<tr id="graphs">
<?php
			}
?>
	<td>
		<a name="<?php print( $name ); ?>">
		<h3><?php print( $title ); ?></h3>
		<p>
		<a href="?key=<?php print( $name ); ?>&term=<?php print( $term ); ?>"><img src="images/graphs/small-<?php print( $name ); ?>-<?php print( $term ); ?>.gif" /></a><br />
		</p>
	</td>
<?php
			if ( $i % 3 == 2 )
			{
?>
</tr>
<?php
			}
			$i++;
		}
?>
</table>
<?php
	}
	else
	{
?>
<p>
ɽñ̤ڤؤ<a href="?term=hour"></a><a href="?term=day&size=large"></a><a href="?term=week&size=large"></a><a href="?term=month&size=large"></a><a href="?term=year&size=large">ǯ</a><br />
<a href="?term=<?php print( $term ); ?>&size=small">̾ɽ</a>
</p>

<?php
		foreach ( $items as $item )
		{
			$name = $item[ 0 ];
			$title = $item[ 1 ];
			$description = $item[ 2 ];
			$advice = $item[ 3 ];
			$parameters = $item[ 4 ];
			$checkes = $item[ 5 ];
?>
<hr size="1">
<table width="800" id="main" cellpadding="0" cellspacing="0">
<tr>
	<td id="comments" valign="top" nowrap>
		<h2><?php print( $title ); ?></h2>
	</td>
	<td id="comments" valign="top">
<?php print( $description ); ?>
	</td>
</tr>
</table>
<br />

<?php
			if ( $parameters != "" )
			{
?>
<table>
<tr>
	<td><h4>ڴϢѥ᡼</h4></td>
</tr>
<tr id="list">
	<td>
		<table cellpadding="0" cellspacing="0">
		<tr>
			<th>ѥ᡼</th>
			<th>̣</th>
			<th></th>
		</tr>
<?php
				$class = "odd";
				foreach ( $parameters as $parameter )
				{
?>
		<tr>
			<td class="<?php print( $class ); ?>"><?php print( $parameter[ 0 ] ); ?></td>
			<td class="<?php print( $class ); ?>"><?php print( $parameter[ 1 ] ); ?></td>
			<td class="<?php print( $class ); ?>nr"><?php print( $parameter[ 2 ] ); ?> <?php print( $parameter[ 3 ] ); ?></td>
		</tr>
<?php
					if ( $class == "odd" )
					{
						$class = "even";
					}
					else
					{
						$class = "odd";
					}
				}
?>
		</table>
	</td>
</tr>
</table>
<br />

<?php
			}
?>
<table width="800" id="graph" cellpadding="0" cellspacing="0">
<tr>
	<td id="graphs" valign="top">
		<img src="images/graphs/large-<?php print( $name ); ?>-<?php print( $term ); ?>.gif" /><br /><br />
	</td>
	<td id="list" valign="top">
<?php
			if ( $checkes != "" )
			{
?>
		<h4>ڸߤξȤ͡</h4>
		<table cellpadding="0" cellspacing="0">
		<tr>
			<th></th>
			<th></th>
		</tr>
<?php
				$class = "odd";
				foreach ( $checkes as $check )
				{
?>
		<tr>
			<td class="<?php print( $class ); ?>"><?php print( $check[ 0 ] ); ?></td>
			<td class="<?php print( $class ); ?>nr"><?php print( $check[ 1 ] ); ?> <?php print( $check[ 2 ] ); ?></td>
		</tr>
<?php
					if ( $class == "odd" )
					{
						$class = "even";
					}
					else
					{
						$class = "odd";
					}
				}
?>
		</table>
		<br />
<?php
			}
			if ( $advice != "" )
			{
?>
		<h4>ڥ塼˥󥰥ɥХ</h4>
		<p>
		<?php print( $advice ); ?>
		</p>
<?php
			}
?>
	</td>
</tr>
</table>

<?php
			if ( $name == "mysql_query" )
			{
?>
<table width="800" id="graph" cellpadding="0" cellspacing="0">
<tr>
	<td colspan="2"><h4>ڥ꡼</h4></td>
</tr>
<tr>
<td id="list" valign="top" colspan="2">
	<a name="queries-detail">
	<p>
	<table cellpadding="0" cellspacing="0">
	<tr>
		<th>꡼</th>
		<th>ȯԲ</th>
		<th>(%)</th>
	</tr>
<?php
				$lineno = 0;
				foreach ( $comms as $comm )
				{
					$class = ( ++$lineno % 2 ) ? "odd" : "even";
?>
	<tr>
		<td class="<?php print $class; ?>"><?php print $comm[ 0 ]; ?></td>
		<td class="<?php print $class; ?>nr"><?php print $comm[ 1 ]; ?></td>
		<td class="<?php print $class; ?>nr">(<?php print round( (int)$comm[ 1 ] / (int)$status[ 'Questions' ] * 100 ); ?> %)</td>
	</tr>
<?php
				}
?>
	</table>
</td>
</tr>
</table>

<?php
			}
			if ( $name == "mysql_slow-query" )
			{
?>
<table width="800" id="graph" cellpadding="0" cellspacing="0">
<tr>
	<td colspan="2"><h4>ڲΥ꡼</h4></td>
</tr>
<tr>
	<td id="list" valign="top" colspan="2">
		<a name="queries-detail">
		<p>
		<table cellpadding="0" cellspacing="0">
		<tr>
			<th></th>
			<th>桼ۥ</th>
			<th>¹Ի</th>
			<th>å</th>
			<th>Կ</th>
			<th>оݹԿ</th>
			<th>꡼</th>
		</tr>
<?php
				$lineno = 0;
				foreach ( $slow_queries_datas as $index => $data )
				{
					if ( (int)( $data[ "query_time" ] ) >= (int)( $variables[ 'long_query_time' ] ) )
					{
						$class = ( ++$lineno % 2 ) ? "odd" : "even";
?>
		<tr>
			<td class="<?php print $class; ?>"><?php print $data[ "time" ]; ?></td>
			<td class="<?php print $class; ?>"><?php print $data[ "user_host" ]; ?></td>
			<td class="<?php print $class; ?>"><?php print $data[ "query_time" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "lock_time" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "rows_sent" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "rows_examined" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "query" ]; ?></td>
		</tr>
<?php
					}
				}
?>
		</table>
	</td>
</tr>
</table>

<table width="800" id="graph" cellpadding="0" cellspacing="0">
<tr>
	<td colspan="2"><h4>ڲΥǥå̤ѥ꡼</h4></td>
</tr>
<tr>
	<td id="list" valign="top" colspan="2">
		<a name="queries-detail">
		<p>
		<table cellpadding="0" cellspacing="0">
		<tr>
			<th></th>
			<th>桼ۥ</th>
			<th>¹Ի</th>
			<th>å</th>
			<th>Կ</th>
			<th>оݹԿ</th>
			<th>꡼</th>
		</tr>
<?php
				$lineno = 0;
				foreach ( $slow_queries_datas as $index => $data )
				{
					if ( (int)$data[ "query_time" ] < (int)$variables[ 'long_query_time' ] )
					{
						$class = ( ++$lineno % 2 ) ? "odd" : "even";
?>
		<tr>
			<td class="<?php print $class; ?>"><?php print $data[ "time" ]; ?></td>
			<td class="<?php print $class; ?>"><?php print $data[ "user_host" ]; ?></td>
			<td class="<?php print $class; ?>"><?php print $data[ "query_time" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "lock_time" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "rows_sent" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "rows_examined" ]; ?> </td>
			<td class="<?php print $class; ?>"><?php print $data[ "query" ]; ?></td>
		</tr>
<?php
					}
				}
?>
		</table>
	</td>
</tr>
</table>
<?php
			}
		}
	}
?>

<div id="footer">
<p align="left">
mMeasure version 1.0.7 - Copyright &copy; 2005-2006 TIME INTERMEDIA CORPORATION
</p>
</div>

</body>

</html>
